############################################################
#                                                          #
#                 Load Observations                        #
#                                                          #
############################################################
#This script its called from UK to set the observations of Catalonia
#we have a doc where we have the reference of the stations that are in catalonia, if we want to change or amplify them we can change the coordinates of the box in set_stations script
print("Load observations")

if(file_format=="ghost"){
  if(time_resolution=="hourly"){
    print(paste0("Setting obs data as hourly mean data.", " ", "Using Ghost obs data"))
    # we prepare a matrix where we will save the observations:
    obs                  <- matrix(NA,ncol=(nrow(local_stations@data)),nrow=0)
    df_obs_all           <- data.frame(obs)
    dates_all            <- data.frame(matrix(NA,ncol= 1,nrow=0))
    
    #we transform from a matrix to a data frame, with the reference of the station as a name of the col
    colnames(df_obs_all) <- c(local_stations@data$ref_obs)
    colnames(dates_all)  <- c("date")
    # finally we extract the observations of certain year_month
    for (y_month in year_month) {
      #obs_path<-"/esarchive/scratch/mhajji/Meriem/RUN_UK_regional/LOOCV/observacions/obs_no2"
      netcdf_obs    <- RNetCDF::open.nc(paste0(obs_path, name_pollutant, "_", y_month, ".nc"))
      
      code_obs      <- RNetCDF::var.get.nc(netcdf_obs, 'station_reference')
      #station_name  <- RNetCDF::var.get.nc(netcdf_obs, "station_name")
      obs_all       <- RNetCDF::var.get.nc(netcdf_obs, name_pollutant)
      
      year            <- as.numeric(substr(y_month, 1, 4))
      month           <- as.numeric(substr(y_month, 5, 6))
      num_days        <- length(RNetCDF::var.get.nc(netcdf_obs, "time"))/24
      date_times_loc  <- data_frame_dates( c(year,month,01,00) , c(year,month,num_days,23) )
      dates_all       <- rbind(dates_all,date_times_loc)
      
      pos_local_stations  <- which(code_obs%in%local_stations@data$ref_obs)
      cat_obs             <- obs_all[,pos_local_stations]
      cat_ref             <- code_obs[pos_local_stations]
      #cat_names           <- station_name[pos_local_stations]
      
      obs_month               <- matrix(NA,ncol=length(cat_obs[1,]),nrow=length(cat_obs[,1])) 
      #cat_obs matriu de 72 col (estacions) i en aquest cas p.ex: 744 (31 dies de generx24h) i fem una obs month buida
      df_obs_month            <- data.frame(obs_month)
      colnames(df_obs_month)  <- paste0(cat_ref)
      df_obs_month[,]         <- cat_obs*obs_constant
      #df_obs_month            <- cbind(date = date_times_loc$date, df_obs_month)
      
      
      df_obs_all              <- rbind.fill(df_obs_all, df_obs_month) #in case there is no data on a certain date, it fills it with NA (rbind.fill)
      if ( ncol(df_obs_all)!=ncol(df_obs_month) ) {
        print(paste0("ERROR: number of monitoring stations is not constant when loading observations. ","Filled with NA in: ",y_month))
      }
    }
    
    df_obs_all <- cbind(dates_all,df_obs_all)
    
    #time_subset permits us to select the observations at the same dates as the model (remember: at first we extract observations monthly)
    df_obs_sub <- time_subset(data = df_obs_all, time_var_name = "date",
                              date_time_begin = date_time_begin,
                              date_time_end = date_time_end)
  }else{
    print("ERROR THE CODE IS NOT FINISHED YET")
  }
  

  
} else {
  
  if(time_resolution=="hourly"){
    print(paste0("Setting obs data as hourly mean data.", " ", "Using Gene obs data"))
    # If the data that we have is hourly (like no2 and o3):
    
    #read the file and extract the station names, and the dates of the pollutant measures:
    netcdf_obs      <- read.csv(paste0(obs_path,"gene_",name_pollutant,"_",read_year,".csv"))
    #netcdf_obs      <- read.csv((paste0(obs_path,"gene_","sconcno2","_",read_year,".csv"))) # per fer una prova amb l'no2
  
    #in netcdf_obs we had diferent variables, in numeric, logi or int type, just in case we pass them all to a numeric type
    
    netcdf_obs$Date <- as.POSIXct(netcdf_obs$Date, format="%Y-%m-%d %H:%M:%S")
    netcdf_obs[,-1] <- dplyr::mutate_all(netcdf_obs[,-1],as.numeric)
    
    df_obs_all              <- netcdf_obs
    colnames(df_obs_all)[1] <- "date"
  
    
    
    #colnames(df_obs_all)[colnames(df_obs_all) == "Date"] <- "date" #no fa falta
   
    start_date  <- format(head(date_times$date, 1), format="%Y-%m-%d %H:%M:%S")
    end_date    <- format(tail(date_times$date, 1), format="%Y-%m-%d %H:%M:%S")
    df_obs_sub  <- subset(df_obs_all, date>=start_date & date <= end_date)
    
  } else{
    print(paste0("Setting obs data as daily mean data.", " ", "Using Gene obs data"))
    
    # If the data that we have is daily mean (like pm10 and pm2.5):
    
    #read the file and extract the station names, and the dates of the pollutant measures:
    netcdf_obs      <- read.csv(paste0(obs_path,"gene_",name_pollutant,"_",read_year,".csv"))
    netcdf_obs$Date <- as.Date(netcdf_obs$Date, format = "%Y-%m-%d")
    #in netcdf_obs we had diferent variables, in numeric, logi or int type, just in case we pass them all to a numeric type
    df_obs_all      <- dplyr::mutate_all(netcdf_obs[,-1],as.numeric)
    df_obs_all$Date <- netcdf_obs$Date
    
    #colnames(df_obs_all)[colnames(df_obs_all) == "Date"] <- "date" #no fa falta
    
    start_date  <- as.Date(as.character(dates[1]), format="%Y%m%d")
    end_date    <- as.Date(as.character(tail(dates,n=1)), format="%Y%m%d")
    df_obs_sub  <- subset(df_obs_all, Date>=start_date & Date <= end_date)
  }
  #----------------
  # ELIMINAR:
  #time_subset permits us to select the observations at the same dates as the model (remember: at first we extract observations monthly)
  
  # Ejemplo con una serie de tiempo llamada "time_series"
  #proves subset
  #time_series <- ts(df_obs_all[,1], start=start_date, frequency=length(df_obs_all$Date))
  #df_obs_sub  <- time_series[start_date:end_date]
  
  #df_obs_sub <- time_subset(data = df_obs_all, time_var_name = "Date",
  #                         date_time_begin = as.Date(as.character(dates[1]), format="%Y%m%d"),
  #                        date_time_end = as.Date(as.character(tail(dates,n=1)), format="%Y%m%d"))
  
  
  # stations      <- colnames(netcdf_obs[,-1])
  # date_obs      <- netcdf_obs$Date
  
  # we prepare a matrix where we will save the observations:
  #obs                  <- matrix(NA,ncol=(length(stations)),nrow=0)
  #df_obs_all           <- data.frame(obs)
  #dates_all            <- data.frame(matrix(NA,ncol= 1,nrow=0))
  
  #we transform from a matrix to a data frame, with the reference of the station as a name of the col
  #colnames(df_obs_all) <- c(stations)
  #colnames(dates_all)  <- c("date")

  # for (n in 1:length(date_obs)){
    #obs_all         <- netcdf_obs[,-1][n,] #Picks up the first day for all stations
    
    #year            <- substr(date_obs, 1, 4)[n]
    #month           <- substr(date_obs, 6, 7)[n]
    #num_days        <- length(date_obs)
    
    # NOPE!!!!:
    #date_times_loc  <- as.character(date_obs[n]) # p.ex: 2021-01-18 01:00:00
    #dates_all       <- rbind(dates_all,date_times_loc)
    #Aqui no crec que haguem de fer el which pk ja son les estacions de cat, pero si treure lat lon
    #pos_local_stations  <- which(stations%in%local_stations@data$ref_obs)
    
    #cat_obs             <- obs_all[,pos_local_stations]
    #cat_ref             <- code_obs[pos_local_stations]
    #cat_names           <- station_name[pos_local_stations]
    
    #obs_month               <- matrix(NA,ncol=length(cat_obs[1,]),nrow=length(cat_obs[,1])) 
    ##cat_obs matriu de 72 col (estacions) i en aquest cas p.ex: 744 (31 dies de generx24h) i fem una obs month buida
    #df_obs_month            <- data.frame(obs_month)
    #colnames(df_obs_month)  <- paste0(cat_ref)
    #df_obs_month[,]         <- cat_obs*obs_constant
    #df_obs_month            <- cbind(date = date_times_loc$date, df_obs_month)
    
    
    #df_obs_all              <- rbind.fill(df_obs_all, df_obs_month) #in case there is no data on a certain date, it fills it with NA (rbind.fill)
    #if ( ncol(df_obs_all)!=ncol(df_obs_month) ) {
     # print(paste0("ERROR: number of monitoring stations is not constant when loading observations. ","Filled with NA in: ",y_month))
    #}
    # ---------------------------------------
}  


if (save_obs){
  saveRDS(object=df_obs_all, file=paste0(save_result,"df_obs_",pollutant,".rds"))
  print("Observations saved")
} else {
  print("Observations have not been saved")
}
