############################################################
#                                                          #
#                 Loop Ordinary Kriging                    #
#                                                          #
############################################################

print("Loop Universal Kriging")
compute_in_UTM        <- TRUE #We want to transform the coordinates from CSR to UTM, it is faster in Universal Kriging
crs_model_utm         <- "+proj=utm +zone=31 +ellps=intl +units=m +no_defs"
crs_model             <- "+proj=longlat +datum=WGS84 +ellps=WGS84 +towgs84=0,0,0" #coordinates sistem

if(time_resolution=="hourly"){
  length_loop=nrow(date_times)

  #LOOCV_total and llista_uk_total is created empty to fill it later with LOOCV and raw model data respectivelly
  llista_uk_total           <- matrix(NA,ncol=nrow(local_stations@data),nrow=0) #list(length=nrow(date_times)) #we will have a large list with a data.frame for each hour
  #colnames(llista_uk_total) <- local_stations$ref_obs #we want a matrix with empty data and the name of stations
  colnames(llista_uk_total) <- local_stations@data$code #gene
  
}else{
  length_loop=length(dates)
  
  #generating a data.frame wih the information about local stations:
  cols              <- colnames(df_obs_sub[,1:(ncol(df_obs_sub)-1)]) #same as: colnames(subset(df_obs_sub, select = -Date))
  selection         <- local_stations@data$code %in% cols
  selected_stations <- local_stations[selection, ]
  new_df            <- data.frame(coords = selected_stations@coords, data = selected_stations@data)
  
  
  # prova tropecientosmil per saber quina es la dif:
  vars_local       <- as.character(local_stations@data$code)
  vars_df          <- names(df_obs_sub)[1:(length(names(df_obs_sub))-1)]
  vars_comunes     <- intersect(vars_local, vars_df)
  #num_vars_comunes <- length(vars_comunes)
  
  
  # Select only the stations that are also in vars_comunes
  local_stations <- subset(local_stations,with(local_stations@data, code %in% vars_comunes))
  
  #No entenc perque les dues linies aquestes no van, es com que la matriu no s'inicialitza, pero bueno funciona amb el data.frame
  #llista_uk_total            <- matrix(NA,ncol=length(vars_comunes),nrow=0) #list(length=nrow(date_times)) #we will have a large list with a data.frame for each hour
  #colnames(llista_uk_total)  <- vars_comunes #nope
  
  llista_uk_total           <- data.frame(matrix(NA, ncol = length(vars_comunes), nrow = 0))
  colnames(llista_uk_total) <- local_stations@data$code
  
  # -------
  # To know if we have an observated local station that its not in local stations data frame, we gonna create a new data frame with the names of the variables
  different_names <- setdiff(names(df_obs_sub),vars_comunes) # which names in df_obs_sub are not in vars_comunes, ojo! l'ordre sí importa
  # Print the different names
  print(different_names)
  
}


#starting OK and LOOCV:
for (hour in 1:length_loop) {
  print(paste0("loop UK number:",hour))
  df_model <- model[,,hour]
  
  #if all the model for a certain hour is nan we cannot apply UK
  if (sum(is.nan(df_model))!=length(df_model)){
    
    #print(df_obs_all[hour,1])
    if(time_resolution=="hourly"){
      df_obs   <- df_obs_sub[hour,-1] 
    }else{
      df_obs <- df_obs_sub[, !names(df_obs_sub) %in% different_names]
      #df_obs <- subset(df_obs_sub, select = -Date) #OJO NO ESTAN ORDENADES COM A LA LLISTA UK!!!
      df_obs <- df_obs[hour,]
    }
    
    #sum(is.na(df_obs)). Hem de marcar-nos fins a quantes observacions fem l'UK, i en cas de no ternir-ne suficients si agafar un variograma del UK previ o bé saltar a l'else
    
    # 1. Interpolate model values at obs locations
    #    1.1. Set spatialpointsdataframe
    #raw model:
    df_model                  <- data.frame(lat=lat_model,lon=lon_model,pollutant=sapply(df_model,as.matrix))
    coordinates(df_model)     <- ~lon+lat
    sp::proj4string(df_model) <- crs_model
    
    #config the coordinates in UTM
    if (compute_in_UTM) {
      df_model <- spTransform(df_model, sp::CRS(crs_model_utm))
    }
    
    #observations:
    df_obs    <- data.frame(lat=local_stations@coords[,2],lon=local_stations@coords[,1],pollutant=as.numeric(df_obs[1,]),code=colnames(df_obs))

    # If we don't have an observation or a negative value we remove it 
    #In OK we don't mind about the values of observations
    #df_obs                     <- na.omit(df_obs) 
    #df_obs[df_obs$pollutant<0,"pollutant"] <- NA
    #df_obs                     <- na.omit(df_obs)
    
    #To avoid what we suppose wrong observations, we will subtitute the values higher than limit microg/m3
    w <- length(which(df_obs$pollutant>limit))
    if(w>=1){
      df_obs[df_obs$pollutant>limit,"pollutant"] <- limit
      print(paste0("The observations has been modified to exceed ", limit, " límit value. The number of observations modified are : ", w, " in the hour:", hour))
    }
    
    coordinates(df_obs)        <- ~lon+lat
    sp::proj4string(df_obs)    <- crs_model
    
    #config the coordinates in UTM
    if (compute_in_UTM) {
      df_obs <- spTransform(df_obs, sp::CRS(crs_model_utm))
    }
    
    #A ver,substitueixo els NA i els valors <0 per 0. EN principi no afecta el OK no? si total interpolem model a estació independentment del seu valor
    # No fa falta, primer pk es un OK i no ens afecta el valor de l'observació real, i segon, si posem 0 després utilitzant el filling amb el IA no sabrem distingir els NA dels 0
    #if(any(is.na(df_obs@data)) | isTRUE(df_obs@data$pollutant<0)){
     # df_obs$pollutant<- ifelse(is.na(df_obs$pollutant)|df_obs$pollutant<0,0,df_obs$pollutant)
      #print(paste0("Negative or NA in the observations has been substituted by zero in the hour:", " ", hour))
    #}
    
    #    1.2 Compute Variogram
    set.seed(1) #we are picking random points in the next line, set.seed permits us to have same points in each loop
    pick_random_points        <- sample(1:nrow(df_model),2000)
    pollutant.fit_ok          <- automap::autofitVariogram(formula=pollutant~1, input_data=df_model[pick_random_points,],model="Ste")
    # Hem posat model='Ste' pk la segona hora del 01/06/2021 peta el variograma, mirar bé perque no s'ajusa
    
    #    1.3 Compute ordinary Kriging
    
    #Del model interpolo cap a les coordenades de les obs 'OK'
    ok_gstat <- gstat(formula=pollutant~1, data = df_model, model = pollutant.fit_ok$var_model, nmax=100)
    
    #Interpolacio del model a les coordenades del conjunt
    OK       <- predict(object=ok_gstat, newdata=df_obs)
    
    #If the variogram has singular matrix then it produces NAN's, so in that case we take a good Variogram instead:
    if(any(is.na(OK@data$var1.pred))){
      print("WARNING: VARIOGRAM DIVERGED! Using a precalculated VARIOGRAM")
      pollutant.fit_ok=readRDS(variogram_ok)
      ok_gstat <- gstat(formula=pollutant~1, data = df_model, model = pollutant.fit_ok$var_model, nmax=100)
      
      #Interpolacio del model a les coordenades del conjunt
      OK <-predict(object=ok_gstat, newdata=df_obs)
    }
    
    llista_uk_h           <- matrix(data=OK$var1.pred, nrow=1)
    colnames(llista_uk_h) <- df_obs$code
    
    llista_uk_total <-  plyr::rbind.fill(as.data.frame(llista_uk_total), as.data.frame(llista_uk_h))
    
  }
  
  else{
    llista_uk_h           <- matrix(data=NA, nrow=1,ncol=(length(df_obs_all)-1))
    colnames(llista_uk_h) <- colnames(df_obs_all[,-1])
    llista_uk_total       <- plyr::rbind.fill(llista_uk_total,as.data.frame(llista_uk_h))
  }
}

llista_uk_total_df       <- as.data.frame(llista_uk_total)

if(time_resolution=="hourly"){
  llista_uk_total_df$dates <- date_times$date 
}else{
  llista_uk_total_df$dates <- df_obs_sub$Date
}


if (save_OK){
  saveRDS(object=llista_uk_total_df, file=paste0(save_result,"llista_uk_",pollutant,"_df.rds"))
  print("Llista OK saved")
} else {
  print("Llista OK have not been saved")
}

############################################################
#                                                          #
#                 Loop LOOCV                               #
#                                                          #
############################################################
print("Loop LOOCV")
#LOOCV_total and llista_uk_total is created empty to fill it later with LOOCV and raw model data respectivelly
LOOCV_total           <- matrix(NA,ncol=nrow(local_stations@data),nrow=0) #list(length=nrow(date_times)) #we will have a large list with a data.frame for each hour
colnames(LOOCV_total) <- local_stations$ref_obs #we want a matrix with empty data and the name of stations

#starting OK and LOOCV:
for (hour in 1:length_loop) {
  print(paste0("loop LOOCV number:",hour))
  
  #extract observations hourly
  
  if(time_resolution=="hourly"){
    df_obs_hour <- df_obs_sub[hour,-1] 
  }else{
    df_obs_hour <- df_obs_sub[, !names(df_obs_sub) %in% different_names]
    df_obs_hour <- df_obs_hour[hour,]
  }
  
  #LOOCV don't work if there is any NA, so first we will remove negative obs and then substitute NA from model value (it will improve using other methods of gap filling)
  if(isTRUE(anyNA(df_obs_hour)) | isTRUE(any(df_obs_hour<0))){
    
    df_obs_hour[sapply(df_obs_hour, is.numeric)] <- lapply(df_obs_hour[sapply(df_obs_hour,is.numeric)],function(x) replace(x, x<0,NA))
    
    # Seleccionar solo las filas con datos completos
    #!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    df_obs_hour                                  <- na.omit(df_obs_hour) #aqui tinc el problemita, m'elimina tot
    
    #df_obs_hour[df_obs_hour<0] <- ifelse(df_obs_hour<0, NA, df_obs_hour[df_obs_hour<0]) # substitutes negative values to NA
    #df_obs_hour <-  coalesce(df_obs_hour, llista_uk_total[hour,]) # Also, it can be done as: df_obs_hour[is.na(df_obs_hour)] <- llista_uk_total[n,][is.na(df_obs_hour)]
    
    print(paste0("Negative or NA in the observations has been substituted by zero in the hour:", " ", hour))
  }
  
  
  #extract raw model interpolated to the obs coords
  ok_hour <- llista_uk_total[hour,]
  
  #We will generate a data frame with obs and raw-model interpolated in the local stations
  llista_loocv                     <- data.frame(lat=local_stations@coords[,2],
                                                 lon=local_stations@coords[,1],
                                                 pollutant_obs=as.numeric(df_obs_hour[1,]),
                                                 pollutant_model=as.numeric(ok_hour[1,]),
                                                 code=colnames(df_obs_hour))
  
  coordinates(llista_loocv)        <- ~lon+lat
  sp::proj4string(llista_loocv)    <- crs_model
  
  #config the coordinates in UTM
  if (compute_in_UTM) {
    sp::proj4string(llista_loocv) <- crs_model_utm
  } else {
    sp::proj4string(llista_loocv) <- crs_model
  }
  
  # Compute LOOCV variogram
  
  pollutant.fit_loocv <- automap::autofitVariogram(formula=pollutant_obs~pollutant_model,input_data=llista_loocv, verbose=FALSE)
  
  #Emergency Variogram if range of the current Variogram it's negative
  if(any(pollutant.fit_loocv$var_model$range<0)){
    print('UK Variogram had negative range')
    pollutant.fit_loocv=readRDS(variogram_uk)
  }
  
  #coef(lm(pollutant_obs ~  pollutant_model , llista_uk))['pollutant_model'] is the same as slope:
  slope <- summary(lm(pollutant_obs ~  pollutant_model , llista_loocv))$coefficients[,1][-1] 
  #p     <-summary(lm(pollutant_obs ~  pollutant_model , llista_uk))$coefficients[,4][-1] #p value.
  
  # if the slope is negative, we substitute all points for that hour by the model
  # Duda existencial tonta: si bé volem corretgir el model perquè no ho substituim per les observacions que són més correctes? R: potser de cara a avaluar el model es lo més correcte...
  if(base::isTRUE(slope[1] < 0)){
    
    #ok_loocv              <- NULL
    ok_loocv              <- as.data.frame(llista_loocv$pollutant_model)
    colnames(ok_loocv)    <- c("var1.pred")
    coordinates(ok_loocv) <- llista_loocv@coords
    
    #config the coordinates in UTM
    if (compute_in_UTM) {
      sp::proj4string(ok_loocv) <- crs_model_utm
    } else {
      sp::proj4string(ok_loocv) <- crs_model
    }
    
    print(paste0("The slope in hour ", hour, " is ", slope, ". We did not apply LOOCV, raw-model value is picked for this hour"))
    
  }else {
    # LOOCV
    ok_loocv             <- krige.cv(pollutant_obs~pollutant_model,llista_loocv,pollutant.fit_loocv$var_model)
    
  }
  # Save LOOCV and raw_model
  uk_loocv_h           <- matrix(data=ok_loocv@data$var1.pred, nrow=1)
  colnames(uk_loocv_h) <- colnames(df_obs_hour)
  
  LOOCV_total          <-  plyr::rbind.fill(as.data.frame(LOOCV_total),as.data.frame(uk_loocv_h))
  
}


LOOCV_total_df       <- as.data.frame(LOOCV_total)
LOOCV_total_df$dates <- date_times$date


#Arrange LOOCV_total_df to remove negative values:
LOOCV_total_df_wd        <- LOOCV_total_df %>% dplyr::select(-dates)

# Realment es podria fer abans de juntar el date al sortir del bucle. Ho deixo així perquè tenim LOOCV guardat amb la data
dates                    <- LOOCV_total_df %>% dplyr::select(dates) 

for(i in 1:nrow(local_stations)){
  LOOCV_total_df_wd[[i]] <- replace(LOOCV_total_df[[i]], LOOCV_total_df[[i]]<0, 0)
}

LOOCV_total_df <- cbind(LOOCV_total_df_wd,dates)

#Verification of negative values 'which(llista_uk_total_df<0)'. At the moment we don't apply it to llista_uk_total because it doesn't have negative values

if (save_LOOCV){
  saveRDS(object=LOOCV_total_df, file=paste0(save_result,"LOOCV_",pollutant,"_df.rds"))
  print("LOOCV saved")
} else {
  print("LOOCV have not been saved")
}

